Package com.datecs.fiscalprinter.SDK.model.BGR

# Class WP500X_BGR

java.lang.Object
com.datecs.fiscalprinter.SDK.FiscalDeviceV2
com.datecs.fiscalprinter.SDK.model.BGR.WP500X_BGR

    public class WP500X_BGR
    extends FiscalDeviceV2

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class com.datecs.fiscalprinter.SDK.FiscalDeviceV2

  `FiscalDeviceV2.cmd255Name`

- ## Field Summary

  ### Fields inherited from class com.datecs.fiscalprinter.SDK.FiscalDeviceV2

  `transport`

- ## Constructor Summary

  Constructors
  Constructor | Description
  --- | ---
  `WP500X_BGR​(AbstractTransportProtocol protocol)` |
  `WP500X_BGR​(java.io.InputStream in, java.io.OutputStream out)` |

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `FiscalResponse` | `command100Variant0Version0​(java.lang.String code)` | Command: 100 (64h) Reading an error
  `FiscalResponse` | `command101Variant0Version0​(java.lang.String operatorCode, java.lang.String oldPassword, java.lang.String newPassword)` | Command: 101 (65h) Set operator password
  `FiscalResponse` | `command103Variant0Version0()` | Command: 103 (67h) Information for the current receipt
  `FiscalResponse` | `command105Variant0Version0​(java.lang.String firstOper, java.lang.String lastOper, java.lang.String clear)` | Command: 105 (69h) Report operators
  `FiscalResponse` | `command106Variant0Version0​(java.lang.String mSec)` | Command: 106 (6Ah) Drawer opening only for FP-705
  `FiscalResponse` | `command107Variant0Version0()` | Command: 107 (6Bh) Defining and reading items Items information;
  `FiscalResponse` | `command107Variant1Version0​(java.lang.String PLU, java.lang.String taxGr, java.lang.String dep, java.lang.String group, java.lang.String priceType, java.lang.String price, java.lang.String addQty, java.lang.String quantity, java.lang.String bar1, java.lang.String bar2, java.lang.String bar3, java.lang.String bar4, java.lang.String itemName)` | Command: 107 (6Bh) Defining and reading items Item programming without unitNameIndex;
  `FiscalResponse` | `command107Variant1Version1​(java.lang.String PLU, java.lang.String taxGr, java.lang.String dep, java.lang.String group, java.lang.String priceType, java.lang.String price, java.lang.String addQty, java.lang.String quantity, java.lang.String bar1, java.lang.String bar2, java.lang.String bar3, java.lang.String bar4, java.lang.String itemName, java.lang.String unitIndex)` | Command: 107 (6Bh) Defining and reading items Item programming with unitIndex;
  `FiscalResponse` | `command107Variant2Version0​(java.lang.String PLU, java.lang.String quantity)` | Command: 107 (6Bh) Defining and reading items Change of the available quantity for item;
  `FiscalResponse` | `command107Variant3Version0​(java.lang.String startPLU, java.lang.String endPLU)` | Command: 107 (6Bh) Defining and reading items Item deleting
  `FiscalResponse` | `command107Variant3Version1()` | Command: 107 (6Bh) Defining and reading items All items will be deleted !!!
  `FiscalResponse` | `command107Variant4Version0​(java.lang.String option, java.lang.String PLU)` | Command: 107 (6Bh) Reading items (Obsolete command - without unitIndex)
  `FiscalResponse` | `command107Variant5Version0​(java.lang.String option, java.lang.String PLU)` | Command: 107 (6Bh) Reading items
  `FiscalResponse` | `command107Variant6Version0​(java.lang.String option)` | Command: 107 (6Bh) Reading items
  `FiscalResponse` | `command109Variant0Version0()` | Command: 109 (6Dh) Print duplicate copy of receipt
  `FiscalResponse` | `command110Variant0Version0()` | Command: 110 (6Eh) Additional daily information Payments
  `FiscalResponse` | `command110Variant1Version0()` | Command: 110 (6Eh) Additional daily information reserved
  `FiscalResponse` | `command110Variant2Version0()` | Command: 110 (6Eh) Additional daily information number and sum of sells; ErrorCode - Indicates an error code.
  `FiscalResponse` | `command110Variant3Version0()` | Command: 110 (6Eh) Additional daily information number and sum of discounts and surcharges
  `FiscalResponse` | `command110Variant4Version0()` | Command: 110 (6Eh) Additional daily information number and sum of corrections and annulled receipts;
  `FiscalResponse` | `command110Variant5Version0()` | Command: 110 (6Eh) Additional daily information number and sum of cash in and cash out operations;
  `FiscalResponse` | `command111Variant0Version0​(java.lang.String reportType, java.lang.String startPLU, java.lang.String endPLU)` | Command: 111 (65h) PLU report
  `FiscalResponse` | `command112Variant0Version0​(java.lang.String wpOperator)` | Command: 112 (70h) Information for operator
  `FiscalResponse` | `command116Variant0Version0​(java.lang.String operation, java.lang.String address, java.lang.String nBytes)` | Command: 116 (74h) Reading FM.
  `FiscalResponse` | `command123Variant0Version0()` | Command: 123 (7Bh) Device information - Serial numbers, Header and Tax numbers;
  `FiscalResponse` | `command123Variant1Version0()` | Command: 123 (7Bh) Device information - Battery and GSM signal status;
  `FiscalResponse` | `command123Variant3Version0()` | Command: 123 (7Bh) Device information - Last fiscal receipt;
  `FiscalResponse` | `command123Variant4Version0()` | Command: 123 (7Bh) Device information - Full EJ verify;
  `FiscalResponse` | `command124Variant0Version0​(java.lang.String startDate, java.lang.String endDate, java.lang.String DocType)` | Command: 124 (7Ch) Search documents in EJ by date
  `FiscalResponse` | `command125Variant0Version0​(java.lang.String docNum, java.lang.String recType)` | Command: 125 (7Dh) Information from EJ - Set document to read;
  `FiscalResponse` | `command125Variant1Version0​(java.lang.String FirstDoc, java.lang.String LastDoc)` | Command: 125 (7Dh) Information from EJ - Read one line as text.
  `FiscalResponse` | `command125Variant2Version0​(java.lang.String FirstDoc, java.lang.String LastDoc)` | Command: 125 (7Dh) Information from EJ - Read as data.
  `FiscalResponse` | `command125Variant3Version0​(java.lang.String option, java.lang.String docNum, java.lang.String recType)` |
  `FiscalResponse` | `command127Variant0Version0​(java.lang.String typeOper, java.lang.String stampName)` | Command: 127 (7Fh) Stamp operations (bitmap printing)
  `FiscalResponse` | `command140Variant0Version0()` | Command: 140 (8Ch) Defining and reading clients Clients information;
  `FiscalResponse` | `command140Variant1Version0​(java.lang.String FIRM, java.lang.String Name, java.lang.String TypeTAXN, java.lang.String TAXN, java.lang.String RecName, java.lang.String VATN, java.lang.String Addr1, java.lang.String Addr2)` | Command: 140 (8Ch) Defining and reading clients Clients programming;
  `FiscalResponse` | `command140Variant2Version0​(java.lang.String firstFIRM, java.lang.String lastFIRM)` | Command: 140 (8Ch) Defining and reading clients Client deleting;
  `FiscalResponse` | `command140Variant3Version0​(java.lang.String FIRM)` | Command: 140 (8Ch) Defining and reading clients Reading client data;
  `FiscalResponse` | `command140Variant4Version0​(java.lang.String Option, java.lang.String startOrTAXN)` | Command: 140 (8Ch) Defining and reading clients Reading client data;
  `FiscalResponse` | `command140Variant5Version0​(java.lang.String Option, java.lang.String startFIRM)` | Command: 140 (8Ch) Defining and reading clients
  `FiscalResponse` | `command144Variant0Version0​(java.lang.String OperationType, java.lang.String Command)` | Command: 144 (90h) Read NAP parameters.
  `FiscalResponse` | `command202Variant0Version0​(java.lang.String data)` |
  `FiscalResponse` | `command202Variant1Version0​(java.lang.String data)` |
  `FiscalResponse` | `command203Variant0Version0​(java.lang.String data)` |
  `FiscalResponse` | `command203Variant1Version0​(java.lang.String data)` |
  `FiscalResponse` | `Command255Read​(FiscalDeviceV2.cmd255Name cmdName, java.lang.String cmdIndex)` |
  `FiscalResponse` | `Command255Write​(FiscalDeviceV2.cmd255Name cmdName, java.lang.String cmdIndex, java.lang.String cmdValue)` |
  `FiscalResponse` | `command33ariant0Version0()` | Command: 33 (21h) Clears the external display.
  `FiscalResponse` | `command35Variant0Version0​(java.lang.String text)` | Command: 35 (23h) Displaying text on second line of the external display.
  `FiscalResponse` | `command38Variant0Version0()` | Command: 38 (26h) Opening a non-fiscal receipt
  `FiscalResponse` | `command39Variant0Version0()` | Command: 39 (27h) Closing a non-fiscal receipt
  `FiscalResponse` | `command42Variant0Version0​(java.lang.String text)` | Command: 42 (2Ah) Printing of a free non-fiscal text
  `FiscalResponse` | `command42Variant1Version0​(java.lang.String text, java.lang.String bold, java.lang.String italic, java.lang.String doubleH, java.lang.String underline, java.lang.String alignment)` | Command: 42 (2Ah) Printing of a free non-fiscal text
  `FiscalResponse` | `command43Variant0Version0​(java.lang.String opCode, java.lang.String opPwd, java.lang.String tillNmb, java.lang.String reasonStorno, java.lang.String docNumber, java.lang.String dateTime, java.lang.String numberOfFM, java.lang.String Invoice, java.lang.String ToInvoice, java.lang.String Reason, java.lang.String NSale)` | Opening of storno documents
  `FiscalResponse` | `command44Variant0Version0​(java.lang.String lines)` | Command: 44 (2Ch) Paper feed
  `FiscalResponse` | `command45Variant0Version0()` | Command: 45 (2Dh) Check for mode connection with PC
  `FiscalResponse` | `command46Variant0Version0()` | Command: 46 (2Eh) Paper cutting
  `FiscalResponse` | `command47Variant0Version0​(java.lang.String text)` | Command: 47 (2Fh) Displaying text on upper line of the external display.
  `FiscalResponse` | `command48Variant0Version0​(java.lang.String opCode, java.lang.String opPwd, java.lang.String tillNmb, java.lang.String invoice)` | Command: 48 (30h) Open fiscal receipt
  `FiscalResponse` | `command48Variant0Version0​(java.lang.String opCode, java.lang.String opPwd, java.lang.String NSale, java.lang.String tillNmb, java.lang.String invoice)` | Command: 48 (30h) Open fiscal receipt
  `FiscalResponse` | `command49Variant0Version0​(java.lang.String pluName, java.lang.String taxCd, java.lang.String price, java.lang.String quantity, java.lang.String discountType, java.lang.String discountValue, java.lang.String department)` | Command: 49 (31h) Registration of sale
  `FiscalResponse` | `command49Variant1Version0​(java.lang.String pluName, java.lang.String taxCd, java.lang.String price, java.lang.String quantity, java.lang.String discountType, java.lang.String discountValue, java.lang.String department, java.lang.String unit)` | Command: 49 (31h) Registration of sale
  `FiscalResponse` | `command50Variant0Version0()` | Command: 50 (32h) Return the active VAT rates
  `FiscalResponse` | `command51Variant0Version0​(java.lang.String print, java.lang.String display, java.lang.String discountType, java.lang.String discountValue)` | Command: 51 (33h) subtotal
  `FiscalResponse` | `command53Variant0Version0​(java.lang.String paidMode, java.lang.String amount)` | Command: 53 (35h) Payments and calculation of the total sum (TOTAL)
  `FiscalResponse` | `command53Variant1Version0​(java.lang.String amount, java.lang.String type)` | Command: 53 (35h) Payments and calculation of the total sum (TOTAL) - debit card;
  `FiscalResponse` | `command53Variant2Version0​(java.lang.String amount, java.lang.String change)` | Command: 53 (35h) Payments and calculation of the total sum (TOTAL) - Foreign currency Foreign currency
  `FiscalResponse` | `command54Variant0Version0​(java.lang.String text)` | Command: 54 (36h) Printing of a free fiscal text
  `FiscalResponse` | `command54Variant1Version0​(java.lang.String text, java.lang.String bold, java.lang.String italic, java.lang.String doubleH, java.lang.String underline, java.lang.String alignment)` | Command: 54 (36h) Printing of a free fiscal text
  `FiscalResponse` | `command55Variant0Version0​(java.lang.String PayType, java.lang.String Amount, java.lang.String RRN, java.lang.String AC)` | Command: 55 (37h) Pinpad commands '1' - Void;Syntax Borica
  `FiscalResponse` | `command55Variant0Version1​(java.lang.String PayType, java.lang.String Amount, java.lang.String Number)` | Command: 55 (37h) Pinpad commands '1' - Void;Syntax UBB
  `FiscalResponse` | `command55Variant0Version2​(java.lang.String PayType, java.lang.String Amount)` | Command: 55 (37h) Pinpad commands '1' - Void;Syntax DSK
  `FiscalResponse` | `command55Variant2Version0()` | Command: 55 (37h) Pinpad commands '2' Copy of last document;
  `FiscalResponse` | `command55Variant2Version0​(java.lang.String Type, java.lang.String Number)` | Command: 55 (37h) Pinpad commands Copy of document by type;
  `FiscalResponse` | `command55Variant3Version0​(java.lang.String Option)` | Command: 55 (37h) Pinpad commands - - can be executed only when receipt is closed.
  `FiscalResponse` | `command55Variant3Version1​(java.lang.String Operation)` | Command: 55 (37h) Pinpad commands - Used when command 53( paying with pinpad ) and command 55 ( option 14 ) returns error along with sum and last digits of card number can be executed only when receipt is open.
  `FiscalResponse` | `command55Variant3Version4​(java.lang.String Amount)` | Command: 55 (37h) Pinpad commands - - Make sale from pinpad, without fiscal receipt; - can be executed only when receipt is closed.
  `FiscalResponse` | `command55Variant4Version0​(java.lang.String DateTime)` | Command: 55 (37h) Pinpad commands - Enter date and time for Pinpad;
  `FiscalResponse` | `command56Variant0Version0()` | Command: 56 (38h) Close fiscal receipt
  `FiscalResponse` | `command57Variant0Version0​(java.lang.String seller, java.lang.String receiver, java.lang.String buyer, java.lang.String address1, java.lang.String address2, java.lang.String typeTAXN, java.lang.String tAXN, java.lang.String vATN)` | Command: 57 (39h) Enter and print invoice data
  `FiscalResponse` | `command58Variant0Version0​(java.lang.String pluCode, java.lang.String quanity, java.lang.String price, java.lang.String discountType, java.lang.String discountValue)` | Command: 58 (3Ah) Registering the sale of a programmed item
  `FiscalResponse` | `command60Variant0Version0()` | Command: 60 (3Ch) cancel fiscal receipt
  `FiscalResponse` | `command61Variant0Version0​(java.lang.String dateTime)` | Command: 61 (3Dh) Set date and time
  `FiscalResponse` | `command62Variant0Version0()` | Command: 62 (3Eh) Read date and time
  `FiscalResponse` | `command64Variant0Version0​(java.lang.String type)` | Command: 64 (40h) Information on the last fiscal entry
  `FiscalResponse` | `command65Variant0Version0​(java.lang.String type)` | Command: 65 (41h) Information on daily taxation
  `FiscalResponse` | `command66Variant0Version0​(java.lang.String start, java.lang.String end)` | Command: 66 (42h) Set invoice interval
  `FiscalResponse` | `command66Variant1Version0​(java.lang.String end)` | Command: 66 (42h) Set invoice interval If the current invoice counter didn't reached the end of the interval.
  `FiscalResponse` | `command66Variant2Version0()` | Command: 66 (42h) Get invoice interval If the current invoice counter didn't reached the end of the interval.
  `FiscalResponse` | `command68Variant0Version0()` | Command: 68 (44h) Number of remaining entries for Z-reports in FM
  `FiscalResponse` | `command69Variant0Version0​(java.lang.String reportType)` | Command: 69 (45h) Reports
  `FiscalResponse` | `command70Variant0Version0​(java.lang.String type, java.lang.String amount)` | Command: 70 (46h) Cash in and Cash out operations
  `FiscalResponse` | `command71Variant0Version0()` | Command: 71 (47h) - General information about the connection with NAP server;
  `FiscalResponse` | `command71Variant1Version0​(java.lang.String infoType)` | Command: 71 (47h) General information
  `FiscalResponse` | `command72Variant0Version0​(java.lang.String serialNumber, java.lang.String tAXnumber)` | Command: 72 (48h) Fiscalization
  `FiscalResponse` | `command74Variant0Version0()` | Command: 74 (4Ah) Reading the Status
  `FiscalResponse` | `command74Variant0Version1()` | Command: 74 (4Ah) Reading the Fiscal QR code
  `FiscalResponse` | `command76Variant0Version0()` | Command: 76 (4Ch) Status of the fiscal receipt
  `FiscalResponse` | `command80Variant0Version0​(java.lang.String hz, java.lang.String mSec)` | Command: 80 (50h) Play sound
  `FiscalResponse` | `command83Variant0Version0​(java.lang.String taxA, java.lang.String taxB, java.lang.String taxC, java.lang.String taxD, java.lang.String taxE, java.lang.String taxF, java.lang.String taxG, java.lang.String taxH, java.lang.String decimalPoint)` | Command: 83 (53h) Programming of VAT rates
  `FiscalResponse` | `command84Variant0Version0​(java.lang.String barcodeType, java.lang.String barcodeData, java.lang.String qRcodeSize)` | Command: 84 (54h) Printing of barcode
  `FiscalResponse` | `command84Variant1Version0​(java.lang.String barcodeData, java.lang.String QRcodeSize)` | Command: 84 (54h) Printing of barcode QR code
  `FiscalResponse` | `command86Variant0Version0()` | Command: 86 (56h) Date of the last fiscal record
  `FiscalResponse` | `command87Variant0Version0​(java.lang.String itemGroup)` | Command: 87 (58h) Get item groups information
  `FiscalResponse` | `command88Variant0Version0​(java.lang.String departmentNumber)` | Command: 88 (58h) Get department information
  `FiscalResponse` | `command89Variant0Version0​(java.lang.String testType)` | Command: 89 (59h) Test of Fiscal Memory
  `FiscalResponse` | `command90Variant0Version0()` | Command: 90 (5Ah) â€“ diagnostic information Diagnostic information without firmware checksum;
  `FiscalResponse` | `command90Variant1Version0()` | Command: 90 (5Ah) â€“ diagnostic information Diagnostic information with firmware checksum;
  `FiscalResponse` | `command91Variant0Version0​(java.lang.String serialNumber, java.lang.String fMnumber)` | Command: 91 (5Bh) Programming of Serial number and FM number
  `FiscalResponse` | `command92Variant0Version0​(java.lang.String type)` | Command: 92 (5Ch) Printing of separating line
  `FiscalResponse` | `command94Variant0Version0​(java.lang.String type, java.lang.String startDate, java.lang.String endDate)` | Command: 94 (5Ð•h) Fiscal memory report by date h) Fiscal memory report by date
  `FiscalResponse` | `command95Variant0Version0​(java.lang.String type, java.lang.String startNumber, java.lang.String endNumber)` | Command: 95 (5Fh) Fiscal memory report by number of Z-report
  `FiscalResponse` | `command98Variant0Version0​(java.lang.String tAXnumber)` | Command: 98 (62h) Programming of TAX number
  `FiscalResponse` | `command99Variant0Version0()` | Command: 99 (63h) Reading the programmed TAX number
  `java.lang.String` | `detectConnectedModel()` |
  `boolean` | `getCapAutoCutter()` |
  `boolean` | `getcapFontSupported()` |
  `java.lang.String` | `getCurrentOpCode()` |
  `java.lang.String` | `getDefaultOpPass()` |
  `java.lang.Integer` | `getMAX_PLU()` |
  `java.lang.Integer` | `getMaxLogoH()` |
  `java.lang.Integer` | `getMaxLogoW()` |
  `int` | `getMaxNonFiscalText()` |
  `int` | `getMaxTextHeaderFooter()` |
  `java.lang.String[]` | `getPrintColumnsSupported()` |
  `boolean` | `iscapFontSupported()` |
  `boolean` | `isCapHasCutter()` |

  ### Methods inherited from class com.datecs.fiscalprinter.SDK.FiscalDeviceV2

  `close, customCommand, getChkInputParams, getDefaultTillNumber, getInfo, getIsStatusCritical, getLastStatus, getMAX_DEPARTMENT, getMAX_PRICE, getMaxDisplayText, getMaxFooterLines, getMaxHeaderLines, getMaxLinesToFeed, getMaxOperators, getMaxStockGroup, getStatusBitBol, getStatusBitDescriptionEn, isThrowErrorCode, isThrowErrorMessage, notDbl, notInt, queryStatus, setChkInputParams, setDebugLevel, setIsStatusCritical, setThrowErrorCode, setThrowErrorMessage, toDouble, toInt`

  ### Methods inherited from class java.lang.Object

  `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### WP500X_BGR

    public WP500X_BGR​(java.io.InputStream in, java.io.OutputStream out) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Parameters:
      `in` -
      `out` -
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### WP500X_BGR

    public WP500X_BGR​(AbstractTransportProtocol protocol) throws java.lang.IllegalArgumentException
    Parameters:
      `protocol` -
    Throws:
      `java.lang.IllegalArgumentException`

- ## Method Details

  - ### detectConnectedModel

    public java.lang.String detectConnectedModel()
    Specified by:
      `detectConnectedModel` in class `FiscalDeviceV2`

  - ### command33ariant0Version0

    public FiscalResponse command33ariant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 33 (21h) Clears the external display.
    Specified by:
      `command33ariant0Version0` in class `FiscalDeviceV2`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command35Variant0Version0

    public FiscalResponse command35Variant0Version0​(java.lang.String text) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 35 (23h) Displaying text on second line of the external display.
    Specified by:
      `command35Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `text` - Text to be sent directly to the external display ( up to 20 symbols );
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command38Variant0Version0

    public FiscalResponse command38Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 38 (26h) Opening a non-fiscal receipt
    Specified by:
      `command38Variant0Version0` in class `FiscalDeviceV2`
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; SlipNumber - Current slip number (1...9999999);
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command39Variant0Version0

    public FiscalResponse command39Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 39 (27h) Closing a non-fiscal receipt
    Specified by:
      `command39Variant0Version0` in class `FiscalDeviceV2`
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; SlipNumber - Current slip number (1...9999999);
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command42Variant0Version0

    public FiscalResponse command42Variant0Version0​(java.lang.String text) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 42 (2Ah) Printing of a free non-fiscal text
    Specified by:
      `command42Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `text` -
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command42Variant1Version0

    public FiscalResponse command42Variant1Version0​(java.lang.String text, java.lang.String bold, java.lang.String italic, java.lang.String doubleH, java.lang.String underline, java.lang.String alignment) throws java.io.IOException, FiscalException
    Command: 42 (2Ah) Printing of a free non-fiscal text

    ï‚· Bold - ï‚· Italic - flag 0 or 1, 1 = print italic text; empty field = normal text; ï‚· DoubleH - flag 0 or 1, 1 = print double height text; empty field = normal text; ï‚· Underline - flag 0 or 1, 1 = print underlined text; empty field = normal text; ï‚· alignment -

    Specified by:
      `command42Variant1Version0` in class `FiscalDeviceV2`
    Parameters:
      `text` -
      `bold` - flag 0 or 1, 1 = print bold text; empty field = normal text;
      `italic` - flag 0 or 1, 1 = print bold text; empty field = normal text;
      `doubleH` - flag 0 or 1, 1 = print bold text; empty field = normal text;
      `underline` - flag 0 or 1, 1 = print bold text; empty field = normal text;
      `alignment` - 0, 1 or 2. 0=left alignment, 1=center, 2=right; empty field = left alignment;
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`

  - ### command43Variant0Version0

    public FiscalResponse command43Variant0Version0​(java.lang.String opCode, java.lang.String opPwd, java.lang.String tillNmb, java.lang.String reasonStorno, java.lang.String docNumber, java.lang.String dateTime, java.lang.String numberOfFM, java.lang.String Invoice, java.lang.String ToInvoice, java.lang.String Reason, java.lang.String NSale) throws java.io.IOException, FiscalException
    Opening of storno documents
    Specified by:
      `command43Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `opCode` - - Operator number from 1...30;
      `opPwd` - - Operator password, ascii string of digits. Lenght from 1...8;
      `tillNmb` - - Number of point of sale from 1...99999;
      `reasonStorno` - - Reason for storno. If Storno has value '0' it opens storno receipt. Reason "operator error"; If Storno has value '1' it opens storno receipt. Reason "refund"; If Storno has value '2' it opens storno receipt. Reason "tax base reduction";
      `docNumber` - - Number of the original document ( global 1...9999999 );
      `dateTime` - - Date and time of the original document( format "DD-MM-YY hh:mm:ss DST" );
      `numberOfFM` - - Fiscal memoty number of the device the issued the original document;
      `Invoice` - - If this parameter has value 'I' it opens an invoice storno/refund receipt.
      `ToInvoice` - - If Invoice is 'I' - Number of the invoice that this receipt is referred to; If Invoice is blank this parameter has to be blank too;
      `Reason` - - If Invoice is 'I' - Reason for invoice storno/refund. If Invoice is blank this parameter has to be blank too;
      `NSale` - - Unique sale number (21 chars "LLDDDDDD-CCCC-DDDDDDD", L[A-Za-z], C[0-9A-Za-z], D[0-9] ) The parameter is not required only if the original document is printed by the cashier and not by the PC program.
    Returns:
      ErrorCode
    Throws:
      `java.io.IOException`
      `FiscalException`

  - ### command44Variant0Version0

    public FiscalResponse command44Variant0Version0​(java.lang.String lines) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 44 (2Ch) Paper feed
    Specified by:
      `command44Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `lines` - Number of lines to feed from 1 to 99. Default: 1;
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command45Variant0Version0

    public FiscalResponse command45Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 45 (2Dh) Check for mode connection with PC
    Specified by:
      `command45Variant0Version0` in class `FiscalDeviceV2`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command46Variant0Version0

    public FiscalResponse command46Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 46 (2Eh) Paper cutting
    Specified by:
      `command46Variant0Version0` in class `FiscalDeviceV2`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command47Variant0Version0

    public FiscalResponse command47Variant0Version0​(java.lang.String text) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 47 (2Fh) Displaying text on upper line of the external display.
    Specified by:
      `command47Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `text` - Text to be sent directly to the external display ( up to 20 symbols );
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command48Variant0Version0

    public FiscalResponse command48Variant0Version0​(java.lang.String opCode, java.lang.String opPwd, java.lang.String tillNmb, java.lang.String invoice) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 48 (30h) Open fiscal receipt
    Specified by:
      `command48Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `opCode` - Operator number from 1...30;
      `opPwd` - Operator password, ascii string of digits. Lenght from 1...8;
      `tillNmb` - Number of point of sale from 1...99999;
      `invoice` - If this parameter has value 'I' it opens an invoice receipt.If left blank it opens fiscal receipt;
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; SlipNumber - Current slip number (1...9999999);
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command48Variant0Version0

    public FiscalResponse command48Variant0Version0​(java.lang.String opCode, java.lang.String opPwd, java.lang.String NSale, java.lang.String tillNmb, java.lang.String invoice) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 48 (30h) Open fiscal receipt
    Specified by:
      `command48Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `opCode` - Operator number from 1...30;
      `opPwd` - Operator password, ascii string of digits. Lenght from 1...8;
      `NSale` - NSale - Unique sale number (21 chars "LLDDDDDD-CCCC-DDDDDDD", L[A-Za-z], C[0-9A-Za-z], D[0-9] )
      `tillNmb` - Number of point of sale from 1...99999;
      `invoice` - If this parameter has value 'I' it opens an invoice receipt.If left blank it opens fiscal receipt;
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; SlipNumber - Current slip number (1...9999999);
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command49Variant1Version0

    public FiscalResponse command49Variant1Version0​(java.lang.String pluName, java.lang.String taxCd, java.lang.String price, java.lang.String quantity, java.lang.String discountType, java.lang.String discountValue, java.lang.String department, java.lang.String unit) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 49 (31h) Registration of sale
    Specified by:
      `command49Variant1Version0` in class `FiscalDeviceV2`
    Parameters:
      `pluName` - Name of product, up to 72 characters not empty string; When the length of the string is greater than 36 chars, the second part ( after 37 pos) is printed in a new line;
      `taxCd` - - Tax code; '1' - vat group A; '2' - vat group B; '3' - vat group C; '4' - vat group D; '5' - vat group E; '6' - vat group F; '7' - vat group G; '8' - vat group H
      `price` - - Product price, with sign '-' at void operations. Format: 2 decimals; up to *9999999.99
      `quantity` - - Quantity of the product ( default: 1.000 ); Format: 3 decimals; up to *999999.999 !!! Max value of {Price} * {Quantity} is *9999999.99. !!!
      `discountType` - - type of discount. '0' or empty - no discount; '1' - surcharge by percentage; '2' - discount by percentage; '3' - surcharge by sum; '4' - discount by sum; If {DiscountType} is non zero, {DiscountValue} have to contain value. The format must be a value with two decimals.
      `discountValue` - -value of discount. a number from 0.00 to 21474836.47 If {DiscountType} is zero or empty, this paramter must be empty.
      `department` - Number of the department 0..99; If '0' - Without department;
      `unit` - - Unit name, up to 6 characters not empty string;
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; SlipNumber - Current slip number (1...9999999);
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command49Variant0Version0

    public FiscalResponse command49Variant0Version0​(java.lang.String pluName, java.lang.String taxCd, java.lang.String price, java.lang.String quantity, java.lang.String discountType, java.lang.String discountValue, java.lang.String department) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 49 (31h) Registration of sale
    Specified by:
      `command49Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `pluName` - Name of product, up to 72 characters not empty string; When the length of the string is greater than 36 chars, the second part ( after 37 pos) is printed in a new line;
      `taxCd` - - Tax code; '1' - vat group A; '2' - vat group B; '3' - vat group C; '4' - vat group D; '5' - vat group E; '6' - vat group F; '7' - vat group G; '8' - vat group H
      `price` - - Product price, with sign '-' at void operations. Format: 2 decimals; up to *9999999.99
      `quantity` - - Quantity of the product ( default: 1.000 ); Format: 3 decimals; up to *999999.999 !!! Max value of {Price} * {Quantity} is *9999999.99. !!!
      `discountType` - - type of discount. '0' or empty - no discount; '1' - surcharge by percentage; '2' - discount by percentage; '3' - surcharge by sum; '4' - discount by sum; If {DiscountType} is non zero, {DiscountValue} have to contain value. The format must be a value with two decimals.
      `discountValue` - -value of discount. a number from 0.00 to 21474836.47 If {DiscountType} is zero or empty, this paramter must be empty.
      `department` - Number of the department 0..99; If '0' - Without department;
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; SlipNumber - Current slip number (1...9999999);
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command50Variant0Version0

    public FiscalResponse command50Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 50 (32h) Return the active VAT rates
    Specified by:
      `command50Variant0Version0` in class `FiscalDeviceV2`
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; nZreport - Number of first Z report; TaxX - Value of Tax group X (0.00...99.99 taxable,100.00=disabled); EntDate - Date of entry ( format DD-MM-YY );
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command51Variant0Version0

    public FiscalResponse command51Variant0Version0​(java.lang.String print, java.lang.String display, java.lang.String discountType, java.lang.String discountValue) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 51 (33h) subtotal
    Specified by:
      `command51Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `print` - - print out; '0' - default, no print out; '1' - the sum of the subtotal will be printed out;
      `discountType` - type of discount. '0' or empty - no discount; '1' - surcharge by percentage; '2' - discount by percentage; '3' - surcharge by sum; '4' - discount by sum; If {DiscountType} is non zero, {DiscountValue} have to contain value. The format must be a value with two decimals.
      `discountValue` - - a number from 0.00 to 21474836.47 for sum operations; a number from 0.00 to 99.99 for percentage operations; If {DiscountType} is zero or empty, this parameter must be empty.
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; SlipNumber - Current slip number (1...9999999); subtotal - subtotal of the receipt ( 0.00...9999999.99 or 0...999999999 depending dec point position ); TaxX - Recepts turnover by vat groups ( 0.00...9999999.99 or 0...999999999 depending dec point position );
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command53Variant0Version0

    public FiscalResponse command53Variant0Version0​(java.lang.String paidMode, java.lang.String amount) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 53 (35h) Payments and calculation of the total sum (TOTAL)
    Specified by:
      `command53Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `paidMode` - -Type of payment; '0' - cash; '1' - credit card; '2' - debit card; '3' - other pay#3 '4' - other pay#4 '5' - other pay#5
      `amount` - - Amount to pay ( 0.00...9999999.99 or 0...999999999 depending dec point position );
    Returns:
      ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; Status - Indicates an error; 'D' - The command passed, return when the paid sum is less than the sum of the receipt. The residual sum due for payment is returned to Amount; 'R' - The command passed, return when the paid sum is greater than the sum of the receipt. A message "CHANGE" will be printed out and the change will be returned to Amount; Amount - The sum tendered ( 0.00...9999999.99 or 0...999999999 depending dec point position )
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command53Variant1Version0

    public FiscalResponse command53Variant1Version0​(java.lang.String amount, java.lang.String type) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 53 (35h) Payments and calculation of the total sum (TOTAL) - debit card;
    Specified by:
      `command53Variant1Version0` in class `FiscalDeviceV2`
    Parameters:
      `type` - - Type of card payment. Only for payment with debit card; '1' - with money; '12'- with points from loyal scheme;
      `amount` - - Amount to pay ( 0.00...9999999.99 or 0...999999999 depending dec point position );
    Returns:
      ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; Status - Indicates an error; Sum - Sum from last transaction in cents; CardNum - Last digits from card number;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command53Variant2Version0

    public FiscalResponse command53Variant2Version0​(java.lang.String amount, java.lang.String change) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 53 (35h) Payments and calculation of the total sum (TOTAL) - Foreign currency Foreign currency
    Specified by:
      `command53Variant2Version0` in class `FiscalDeviceV2`
    Parameters:
      `amount` - - Amount to pay ( 0.00...9999999.99 or 0...999999999 depending dec point position );
      `change` - Type of change. Only if PaidMode = '6'; '0' - current currency;
    Returns:
      ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; Status - Indicates an error; 'D' - The command passed, return when the paid sum is less than the sum of the receipt. The residual sum due for payment is returned to Amount; 'R' - The command passed, return when the paid sum is greater than the sum of the receipt. A message "CHANGE" will be printed out and the change will be returned to Amount; Amount - The sum tendered ( 0.00...9999999.99 or 0...999999999 depending dec point position );
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command54Variant0Version0

    public FiscalResponse command54Variant0Version0​(java.lang.String text) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 54 (36h) Printing of a free fiscal text
    Specified by:
      `command54Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `text` - - text of 0...XX symbols, XX = PrintColumns-2;
    Returns:
      ErrorCode - Indicates an error code. If command passed, ErrorCode is 0;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command54Variant1Version0

    public FiscalResponse command54Variant1Version0​(java.lang.String text, java.lang.String bold, java.lang.String italic, java.lang.String doubleH, java.lang.String underline, java.lang.String alignment) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 54 (36h) Printing of a free fiscal text
    Specified by:
      `command54Variant1Version0` in class `FiscalDeviceV2`
    Parameters:
      `text` - text of 0...XX symbols, XX = PrintColumns-2;
      `bold` - flag 0 or 1, 1 = print bold text; empty field = normal text;
      `italic` - flag 0 or 1, 1 = print bold text; empty field = normal text;
      `doubleH` - flag 0 or 1, 1 = print bold text; empty field = normal text;
      `underline` - flag 0 or 1, 1 = print bold text; empty field = normal text;
      `alignment` - 0, 1 or 2. 0=left alignment, 1=center, 2=right; empty field = left alignment;
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command55Variant0Version0

    public FiscalResponse command55Variant0Version0​(java.lang.String PayType, java.lang.String Amount, java.lang.String RRN, java.lang.String AC) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 55 (37h) Pinpad commands '1' - Void;Syntax Borica
    Specified by:
      `command55Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `PayType` - - Type of payment: 7 - Return with money, 13 - Return with points from loyal scheme;
      `Amount` - - The amount of the transaction;
      `RRN` - - RRN of the transaction(12 digits max);
      `AC` - - AC of the transaction(6 digits max); If pinpad is configured for UBB:
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command55Variant0Version1

    public FiscalResponse command55Variant0Version1​(java.lang.String PayType, java.lang.String Amount, java.lang.String Number) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 55 (37h) Pinpad commands '1' - Void;Syntax UBB
    Specified by:
      `command55Variant0Version1` in class `FiscalDeviceV2`
    Parameters:
      `PayType` - - Type of payment: 16 - Return with AC number, 17 - Return with receipt number;
      `Amount` - - The amount of the transaction;
      `Number` - - depent on PayType( 16 - AC number, 17 - receipt number )
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command55Variant0Version2

    public FiscalResponse command55Variant0Version2​(java.lang.String PayType, java.lang.String Amount) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 55 (37h) Pinpad commands '1' - Void;Syntax DSK
    Specified by:
      `command55Variant0Version2` in class `FiscalDeviceV2`
    Parameters:
      `PayType` - - Type of payment: 17 - Void last document;
      `Amount` - - The amount of the transaction;
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command55Variant2Version0

    public FiscalResponse command55Variant2Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 55 (37h) Pinpad commands '2' Copy of last document;
    Specified by:
      `command55Variant2Version0` in class `FiscalDeviceV2`
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command55Variant2Version0

    public FiscalResponse command55Variant2Version0​(java.lang.String Type, java.lang.String Number) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 55 (37h) Pinpad commands Copy of document by type;
    Specified by:
      `command55Variant2Version0` in class `FiscalDeviceV2`
    Parameters:
      `Type` - - 1 - RRN, 2 - AC, 3 - Number of the transaction;
      `Number` - - depends on Type( RRN - 12 digits max, AC - 6 digits max, Number - 6 digits max );
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command55Variant3Version0

    public FiscalResponse command55Variant3Version0​(java.lang.String Option) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 55 (37h) Pinpad commands - - can be executed only when receipt is closed.
    Specified by:
      `command55Variant3Version0` in class `FiscalDeviceV2`
    Parameters:
      `Option` - '4' - Copy of all documents; '5' - End of day from Pinpad; '6' - Report from pinpad; '7' - Full report from pinpad;

      '9' - Check connection with Pinpad; '10' - Check connection with server; '11' - Loyalty balance; '12' - Get update; '15' - Print receipt for pinpad after succesfull transaction. Must be executed after command 53( when paying with pinpad ) and after command 56( when paying with pinpad );

    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command55Variant3Version1

    public FiscalResponse command55Variant3Version1​(java.lang.String Operation) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 55 (37h) Pinpad commands - Used when command 53( paying with pinpad ) and command 55 ( option 14 ) returns error along with sum and last digits of card number can be executed only when receipt is open.
    Specified by:
      `command55Variant3Version1` in class `FiscalDeviceV2`
    Parameters:
      `Operation` - - Operation for execution; '1' - Print receipt; '2' - Void transaction from pinpad;
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command55Variant3Version4

    public FiscalResponse command55Variant3Version4​(java.lang.String Amount) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 55 (37h) Pinpad commands - - Make sale from pinpad, without fiscal receipt; - can be executed only when receipt is closed.
    Specified by:
      `command55Variant3Version4` in class `FiscalDeviceV2`
    Parameters:
      `Amount` - - Amount for sale;
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0;

      AC - Authorization code for transaction; CardData - Type of card payment( unknown: -1, chip: 0, contactless: 1, magnetic stripe: 2, manually: 3 ); CardNumber - Card number; MIDNumber - Merchant ID; RRN - RRN number for transaction; TIDNumber - Terminal ID; TransAmount - Transaction amount; TransDate - Transaction date; TransTime - Transaction time; TransNumber - Transaction number; TransStatus - Transaction status( approved: 0, declined: 1, error: 2 ); TransType - Transaction type; FulLResponseCode - Complete response code;

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command55Variant4Version0

    public FiscalResponse command55Variant4Version0​(java.lang.String DateTime) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 55 (37h) Pinpad commands - Enter date and time for Pinpad;
    Specified by:
      `command55Variant4Version0` in class `FiscalDeviceV2`
    Parameters:
      `DateTime` - - Date and time in format: "DD-MM-YY hh:mm:ss DST"; DD - Day; MM - Month; YY - Year; hh - Hour; mm - Minute; ss - Second; DST - Text "DST" if exist time is Summer time;
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command56Variant0Version0

    public FiscalResponse command56Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 56 (38h) Close fiscal receipt
    Specified by:
      `command56Variant0Version0` in class `FiscalDeviceV2`
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; SlipNumber - Current slip number (1...9999999);
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command57Variant0Version0

    public FiscalResponse command57Variant0Version0​(java.lang.String seller, java.lang.String receiver, java.lang.String buyer, java.lang.String address1, java.lang.String address2, java.lang.String typeTAXN, java.lang.String tAXN, java.lang.String vATN) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 57 (39h) Enter and print invoice data
    Specified by:
      `command57Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `seller` - -Name of the client; 36 symbols max; if left blank prints empty space for hand-writing
      `receiver` - - Name of the receiver; 36 symbols max; if left blank prints empty space for hand-writing
      `buyer` - - Name of the buyer; 36 symbols max; if left blank prints empty space for hand-writing
      `address1` - - First line of the address; 36 symbols max; if left blank prints empty space for hand-writing
      `address2` - - Second line of the address; 36 symbols max; if left blank prints empty space for handwriting
      `typeTAXN` - - Type of client's tax number. 0-BULSTAT; 1-EGN; 2-LNCH; 3-service number
      `tAXN` - - Client's tax number. ascii string of digits 8...13 Optional parameters:
      `vATN` - - VAT number of the client. 10...14 symbols
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command58Variant0Version0

    public FiscalResponse command58Variant0Version0​(java.lang.String pluCode, java.lang.String quanity, java.lang.String price, java.lang.String discountType, java.lang.String discountValue) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 58 (3Ah) Registering the sale of a programmed item
    Specified by:
      `command58Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `pluCode` - -The code of the item. from 1...3000
      `quanity` - - Example: 1.000; Max: 999999.999;
      `price` -
      `discountType` - - type of discount. '0' or empty - no discount; '1' - surcharge by percentage; '2' - discount by percentage; '3' - surcharge by sum; '4' - discount by sum;
      `discountValue` - value of discount. a number from 0.00 to 21474836.47 If {DiscountType} is zero or empty, this parameter must be empty. Note Void operations are made by placing '-' before PluCode! In order to make void operation the Price parameter must be the same as the price at which you sold the item.
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; SlipNumber - Current slip number (1...9999999);
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command60Variant0Version0

    public FiscalResponse command60Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 60 (3Ch) cancel fiscal receipt
    Specified by:
      `command60Variant0Version0` in class `FiscalDeviceV2`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command61Variant0Version0

    public FiscalResponse command61Variant0Version0​(java.lang.String dateTime) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 61 (3Dh) Set date and time
    Specified by:
      `command61Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `dateTime` - - Date and time in format: "DD-MM-YY hh:mm:ss DST"; DD - Day; MM - Month; YY - Year; hh - Hour; mm - Minute; ss - Second; DST - Text "DST" if exist time is Summer time;
    Returns:
      ErrorCode - Indicates an error code. If command passed, ErrorCode is 0;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command62Variant0Version0

    public FiscalResponse command62Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 62 (3Eh) Read date and time
    Specified by:
      `command62Variant0Version0` in class `FiscalDeviceV2`
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; DateTime - Date and time in format: "DD-MM-YY hh:mm:ss DST"; DD - Day; MM - Month; YY - Year; hh - Hour; mm - Minute; ss - Second; DST - Text "DST" if exist time is Summer time;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command64Variant0Version0

    public FiscalResponse command64Variant0Version0​(java.lang.String type) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 64 (40h) Information on the last fiscal entry
    Specified by:
      `command64Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `type` - - Type of returned data. Default: 0; 0 - Turnover on TAX group; 1 - Amount on TAX group; 2 - Storno turnover on TAX group; 3 - Storno amount on TAX group;
    Returns:
      ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; nRep - Number of report 1...1825 or 3650; SumX - Depend on Type. X is the letter of TAX group ( 0.00...9999999.99 or 0...999999999 depending dec point position ); Date - Date of fiscal record in format DD-MM-YY;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command65Variant0Version0

    public FiscalResponse command65Variant0Version0​(java.lang.String type) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 65 (41h) Information on daily taxation
    Specified by:
      `command65Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `type` - - Type of returned data. Default: 0; 0 - Turnover on TAX group; 1 - Amount on TAX group; 2 - Storno turnover on TAX group; 3 - Storno amount on TAX group;
    Returns:
      ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; nRep - Number of report (1...1825 or 3650); SumX - Depend on Type. X is the letter of TAX group ( 0.00...9999999.99 or 0...999999999 depending dec point position );
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command66Variant0Version0

    public FiscalResponse command66Variant0Version0​(java.lang.String start, java.lang.String end) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 66 (42h) Set invoice interval
    Specified by:
      `command66Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `start` - - The starting number of the interval. Max 10 digits (1...9999999999).
      `end` - - The ending number of the interval. Max 10 digits (1...9999999999).
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command66Variant1Version0

    public FiscalResponse command66Variant1Version0​(java.lang.String end) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 66 (42h) Set invoice interval If the current invoice counter didn't reached the end of the interval.
    Specified by:
      `command66Variant1Version0` in class `FiscalDeviceV2`
    Parameters:
      `end` - The ending number of the interval. Max 10 digits (1...9999999999).
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command66Variant2Version0

    public FiscalResponse command66Variant2Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 66 (42h) Get invoice interval If the current invoice counter didn't reached the end of the interval.
    Specified by:
      `command66Variant2Version0` in class `FiscalDeviceV2`
    Returns:
      - Start - The current starting value of the interval (1...9999999999) End - The current ending value of the interval (1...9999999999) Current - The current invoice receipt number (1...9999999999)
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command68Variant0Version0

    public FiscalResponse command68Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 68 (44h) Number of remaining entries for Z-reports in FM
    Specified by:
      `command68Variant0Version0` in class `FiscalDeviceV2`
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; ReportsLeft - The number of remaining entries for Z-reports in FM (1...1825 or 3650).
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command69Variant0Version0

    public FiscalResponse command69Variant0Version0​(java.lang.String reportType) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 69 (45h) Reports
    Specified by:
      `command69Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `reportType` - - Report type; 'X' - X report; 'Z' - Z report;
    Returns:
      ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; nRep - Number of Z-report (1...1825 or 3650); TotX - Total sum accumulated by TAX group X - fiscal operations ( 0.00...9999999.99 or 0...999999999 depending dec point position );
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command70Variant0Version0

    public FiscalResponse command70Variant0Version0​(java.lang.String type, java.lang.String amount) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 70 (46h) Cash in and Cash out operations
    Specified by:
      `command70Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `type` - - type of operation; '0' - cash in; '1' - cash out; '2' - cash in - (foreign currency); '3' - cash out - (foreign currency); Optional parameters:
      `amount` - - the sum ( 0.00...9999999.99 or 0...999999999 depending dec point position ); If Amount=0, the only Answer is returned, and receipt does not print.
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; CashSum - cash in safe sum ( 0.00...9999999.99 or 0...999999999 depending dec point position ); 16
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command71Variant0Version0

    public FiscalResponse command71Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 71 (47h) - General information about the connection with NAP server;
    Specified by:
      `command71Variant0Version0` in class `FiscalDeviceV2`
    Returns:
      - -ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; -LastDate - Last connection to the server; -NextDate - Next connection to the server; -Zrep - Last send Z report; -ZErrZnum - Number of Z report with error; -ZErrCnt - Sum of all errors for Z reports; -ZErrNum - Error number from the server; -SellErrnDoc - Number of sell document with error; -SellErrCnt - Sum of all errors for sell documents; -SellErrStatus - Error number from the server; -SellNumber - Last received document number from server; -SellDate - The date and time of last received document from server; -LastErr- Last error from server; -RemMinutes- Remaining minutes until next GetDeviceInfo request;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command71Variant1Version0

    public FiscalResponse command71Variant1Version0​(java.lang.String infoType) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 71 (47h) General information
    Specified by:
      `command71Variant1Version0` in class `FiscalDeviceV2`
    Parameters:
      `infoType` - - Type of the information printed. Default: 0; '0' - General diagnostic information about the device; '1' - test of the modem;* '3' - print information about the connection with NAP server; '4' - test of the LAN interface if present; '6' - test of the SD card performance; '9' - test of the Ble module ( if present ); '10' - test of the modem without PPP connection;
    Returns:
      ErrorCode - Indicates an error code. If command passed, ErrorCode is 0;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command72Variant0Version0

    public FiscalResponse command72Variant0Version0​(java.lang.String serialNumber, java.lang.String tAXnumber) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 72 (48h) Fiscalization
    Specified by:
      `command72Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `serialNumber` - - Serial Number ( Two letters and six digits: XX123456);
      `tAXnumber` - - TAX number (max 13 characters);
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command74Variant0Version0

    public FiscalResponse command74Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 74 (4Ah) Reading the Status
    Specified by:
      `command74Variant0Version0` in class `FiscalDeviceV2`
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; StatusBytes - Status Bytes ( See the description of the status bytes ).
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command74Variant0Version1

    public FiscalResponse command74Variant0Version1() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 74 (4Ah) Reading the Fiscal QR code
    Specified by:
      `command74Variant0Version1` in class `FiscalDeviceV2`
    Returns:
      - PrintBufferStatus - 0...1 â€¢ '0' â€“ buffer is not empty; â€¢ '1' â€“ empty buffer, no lines pending; ReceiptStatus - Status of the current receipt: â€¢ '0' â€“ Receipt is closed; â€¢ '1' â€“ Normal receipt is open; â€¢ '2' â€“ Storno receipt is open. Reason "mistake by operator"; â€¢ '3' â€“ Storno receipt is open. Reason "refund"; â€¢ '4' â€“ Storno receipt is open. Reason "tax base reduction"; â€¢ '5' â€“ Standard non-fiscal receipt is open; â€¢ '6' â€“ Debit invoice is open; â€¢ '7' â€“ Credit invoice is open. Reason "mistake by operator"; â€¢ '8' â€“ Credit invoice is open. Reason "refund"; â€¢ '9' â€“ Credit invoice is open. Reason "tax base reduction";

      Number - 1...9999999 The number of the current or the last receipt. QRamount - 0.00...9999999.99 or 0...999999999 Fiscal QR code â€“ the amount of the last fiscal receipt. QRnumber - 1...9999999 Fiscal QR code â€“ the slip number of the last fiscal receipt. QRdatetime - DD-MM-YY hh:mm:ss DST : Fiscal QR code â€“ the date and time of the last fiscal receipt.

    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command76Variant0Version0

    public FiscalResponse command76Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 76 (4Ch) Status of the fiscal receipt
    Specified by:
      `command76Variant0Version0` in class `FiscalDeviceV2`
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; IsOpen - 1 - Receipt is open, 0 - receipt is closed; Number - The number of the current or the last receipt (1...9999999); Items - number of sales registered on the current or the last fiscal receipt (0...9999999); Amount - The sum from the current or the last fiscal receipt ( 0.00...9999999.99 or 0...999999999 depending dec point position ); Payed - The sum paid for the current or the last receipt ( 0.00...9999999.99 or 0...999999999 depending dec point position );
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command80Variant0Version0

    public FiscalResponse command80Variant0Version0​(java.lang.String hz, java.lang.String mSec) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 80 (50h) Play sound
    Specified by:
      `command80Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `hz` -
      `mSec` -
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command83Variant0Version0

    public FiscalResponse command83Variant0Version0​(java.lang.String taxA, java.lang.String taxB, java.lang.String taxC, java.lang.String taxD, java.lang.String taxE, java.lang.String taxF, java.lang.String taxG, java.lang.String taxH, java.lang.String decimalPoint) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 83 (53h) Programming of VAT rates
    Specified by:
      `command83Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `taxA` - - - Value of VAT rate X; 0.00...99.99 - enabled; 100.00 - disabled;
      `taxB` -
      `taxC` -
      `taxD` -
      `taxE` -
      `taxF` -
      `taxG` -
      `taxH` -
      `decimalPoint` - - value: 0 or 2( if decimal_point = 0 - work with integer prices. If decimal_point = 2 - work with fract prices );
    Returns:
      -ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; RemainingChanges - number of remaining changes (1...30);
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command84Variant0Version0

    public FiscalResponse command84Variant0Version0​(java.lang.String barcodeType, java.lang.String barcodeData, java.lang.String qRcodeSize) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 84 (54h) Printing of barcode
    Specified by:
      `command84Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `barcodeType` - Type of barcode; '1' - EAN8 barcode. Data must contain only 8 digits; '2' - EAN13 barcode. Data must contain only 13 digits; '3' - Code128 barcode. Data must contain symbols with ASCII codes between 32 and 127. Data length is between 3 and 31 symbols; '4' - QR code. Data must contain symbols with ASCII codes between 32 and 127. Data length is between 3 and 279 symbols; '5' - Interleave 2of5 barcode. Data must contain only digits, from 3 to 22 chars; '6' - PDF417 truncated Data must contain symbols with ASCII codes between 32 and 127. Data length is between 3 and 400 symbols; '7' - PDF417 normal Data must contain symbols with ASCII codes between 32 and 127. Data length is between 3 and 400 symbols;
      `barcodeData` - -Data of the barcode; Length of {Data} depends on the type of the barcode.
      `qRcodeSize` - - Dots multiplier ( 3...10 ) for QR barcodes and PDF417 barcodes. Default: 4;
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command84Variant1Version0

    public FiscalResponse command84Variant1Version0​(java.lang.String barcodeData, java.lang.String QRcodeSize) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 84 (54h) Printing of barcode QR code
    Specified by:
      `command84Variant1Version0` in class `FiscalDeviceV2`
    Parameters:
      `barcodeData` - QR code. {Data} must contain symbols with ASCII codes between 32 and 127. {Data} length is between 3 and 279 symbols;
      `QRcodeSize` - - Dots multiplier ( 3...10 ) default=4;
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command86Variant0Version0

    public FiscalResponse command86Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 86 (56h) Date of the last fiscal record
    Specified by:
      `command86Variant0Version0` in class `FiscalDeviceV2`
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; DateTime - The date and the time of the last fiscal record in format: DD-MM-YYYY hh:mm:ss;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command87Variant0Version0

    public FiscalResponse command87Variant0Version0​(java.lang.String itemGroup) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 87 (58h) Get item groups information
    Specified by:
      `command87Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `itemGroup` - - Number of item group; If ItemGroup is empty - item group report;
    Returns:
      ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; TotSales - Number of sales for this item group for day; TotSum - Accumulated sum for this item group for day; Name - Name of item group;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command88Variant0Version0

    public FiscalResponse command88Variant0Version0​(java.lang.String departmentNumber) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 88 (58h) Get department information
    Specified by:
      `command88Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `departmentNumber` - - Number of department; If Department is empty - department report;
    Returns:
      ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; TaxGr - Tax group of department; Price - Price of department; TotSales - Number of sales for this department for day; TotSum - Accumulated sum for this department for day; STotSales - Number of storno operations for this department for day; STotSum - Accumulated sum from storno operations for this department for day; Name - Name of department;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command89Variant0Version0

    public FiscalResponse command89Variant0Version0​(java.lang.String testType) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 89 (59h) Test of Fiscal Memory
    Specified by:
      `command89Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `testType` - 0 - Read test. 1 - Write and read test;
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; Records - Number of records left (0...16).
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command90Variant0Version0

    public FiscalResponse command90Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 90 (5Ah) â€“ diagnostic information Diagnostic information without firmware checksum;
    Specified by:
      `command90Variant0Version0` in class `FiscalDeviceV2`
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; Name - Device name ( up to 32 symbols ). FwRev - Firmware version. 6 symbols; FwDate - Firmware date DDMMMYY. 7 symbols; FwTime - Firmware time hhmm. 4 symbols. Checksum - Firmware checksum. 4 symbols; Sw - Switch from Sw1 to Sw8. 8 symbols (not used at this device, always 00000000); SerialNumber - Serial Number ( Two letters and six digits: XX123456); {FMNumber} â€“Fiscal memory number (8 digits)
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command90Variant1Version0

    public FiscalResponse command90Variant1Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 90 (5Ah) â€“ diagnostic information Diagnostic information with firmware checksum;
    Specified by:
      `command90Variant1Version0` in class `FiscalDeviceV2`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command91Variant0Version0

    public FiscalResponse command91Variant0Version0​(java.lang.String serialNumber, java.lang.String fMnumber) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 91 (5Bh) Programming of Serial number and FM number
    Specified by:
      `command91Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `serialNumber` - - Serial Number ( Two letters and six digits: XX123456);
      `fMnumber` - - Fiscal Memory Number (Eight digits);
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command92Variant0Version0

    public FiscalResponse command92Variant0Version0​(java.lang.String type) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 92 (5Ch) Printing of separating line
    Specified by:
      `command92Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `type` - - Type of the separating line. '1' - Separating line with the symbol '-'; '2' - Separating line with the symbols '-' and ' '; '3' - Separating line with the symbol '=';
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command94Variant0Version0

    public FiscalResponse command94Variant0Version0​(java.lang.String type, java.lang.String startDate, java.lang.String endDate) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 94 (5Ð•h) Fiscal memory report by date h) Fiscal memory report by date
    Specified by:
      `command94Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `type` - - 0 - short; 1 - detailed;
      `startDate` - - Start date. Default: Date of fiscalization ( format DD-MM-YY );
      `endDate` - - End date. Default: Current date ( format DD-MM-YY );
    Returns:
      ErrorCode - Indicates an error code. If command passed, ErrorCode is 0;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command95Variant0Version0

    public FiscalResponse command95Variant0Version0​(java.lang.String type, java.lang.String startNumber, java.lang.String endNumber) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 95 (5Fh) Fiscal memory report by number of Z-report
    Specified by:
      `command95Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `type` - - 0 - short; 1 - detailed;
      `startNumber` - - First block in the report. Default: 1;
      `endNumber` - - Last block in the report. Default: number of last Z report;
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command98Variant0Version0

    public FiscalResponse command98Variant0Version0​(java.lang.String tAXnumber) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 98 (62h) Programming of TAX number
    Specified by:
      `command98Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `tAXnumber` - - TAX number (max 13 characters);
    Returns:
      ErrorCode - Indicates an error code. If command passed, ErrorCode is 0;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command99Variant0Version0

    public FiscalResponse command99Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 99 (63h) Reading the programmed TAX number
    Specified by:
      `command99Variant0Version0` in class `FiscalDeviceV2`
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; TAXnumber - TAX number (max 13 characters);
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command100Variant0Version0

    public FiscalResponse command100Variant0Version0​(java.lang.String code) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 100 (64h) Reading an error
    Specified by:
      `command100Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `code` - - Code of the error(negative number);
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; Code - Code of the error, to be explained; ErrorMessage - Explanation of the error in Code;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command101Variant0Version0

    public FiscalResponse command101Variant0Version0​(java.lang.String operatorCode, java.lang.String oldPassword, java.lang.String newPassword) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 101 (65h) Set operator password
    Specified by:
      `command101Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `operatorCode` - - Operator number from 1...30;
      `oldPassword` - - Operator old password or administrator (oper29 and oper30) password. Can be blank if service jumper is on
      `newPassword` - Operator password, ascii string of digits. Lenght from 1...8;
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command103Variant0Version0

    public FiscalResponse command103Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 103 (67h) Information for the current receipt
    Specified by:
      `command103Variant0Version0` in class `FiscalDeviceV2`
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; SumVATx - The current accumulated sum on VATx ( 0.00...9999999.99 or 0...999999999 depending dec point position ); Inv - '1' if it is expanded receipt; '0' if it is simplified receipt; InvNmb - Number of the next invoice (up to 10 digits)
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command105Variant0Version0

    public FiscalResponse command105Variant0Version0​(java.lang.String firstOper, java.lang.String lastOper, java.lang.String clear) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 105 (69h) Report operators
    Specified by:
      `command105Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `firstOper` - - First operator. Default: 1 (1...30);
      `lastOper` - - Last operator. Default: Maximum operator number (1...30);
      `clear` - - Clear registers for operators. Default: 0; '0' - Does not clear registers for operators. '1' - Clear registers for operators.
    Returns:
      ErrorCode - Indicates an error code. If command passed, ErrorCode is 0;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command106Variant0Version0

    public FiscalResponse command106Variant0Version0​(java.lang.String mSec) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 106 (6Ah) Drawer opening only for FP-705
    Specified by:
      `command106Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `mSec` - - The length of the impulse in milliseconds. ( 0...65535 )
    Returns:
      ErrorCode - Indicates an error code. If command passed, ErrorCode is 0;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant0Version0

    public FiscalResponse command107Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 107 (6Bh) Defining and reading items Items information;
    Specified by:
      `command107Variant0Version0` in class `FiscalDeviceV2`
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; Total - Total count of the programmable items ( 3000 ); Prog - Total count of the programmed items ( 0...3000); NameLen - Maximum length of item name ( 72 );
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant1Version0

    public FiscalResponse command107Variant1Version0​(java.lang.String PLU, java.lang.String taxGr, java.lang.String dep, java.lang.String group, java.lang.String priceType, java.lang.String price, java.lang.String addQty, java.lang.String quantity, java.lang.String bar1, java.lang.String bar2, java.lang.String bar3, java.lang.String bar4, java.lang.String itemName) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 107 (6Bh) Defining and reading items Item programming without unitNameIndex;
    Specified by:
      `command107Variant1Version0` in class `FiscalDeviceV2`
    Parameters:
      `PLU` - - Item number ( For ECRs 1...100000; For FPs 1...3000 );
      `taxGr` - - VAT group (letter 'A'...'H' or cyrillic);
      `dep` - - Department ( 0...99 );
      `group` - - Stock group (1...99);
      `priceType` - - Price type ('0' - fixed price, '1' - free price, '2' - max price) ;
      `price` - - Price ( 0.00...9999999.99 or 0...999999999 depending dec point position );
      `addQty` - - A byte with value 'A',Change of the available quantity for item;
      `quantity` - - Stock quantity ( 0.001...99999.999 );
      `bar1` - - Barcode X ( up to 13 digits );
      `bar2` -
      `bar3` -
      `bar4` -
      `itemName` - - Item name (up to 72 symbols);
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant1Version1

    public FiscalResponse command107Variant1Version1​(java.lang.String PLU, java.lang.String taxGr, java.lang.String dep, java.lang.String group, java.lang.String priceType, java.lang.String price, java.lang.String addQty, java.lang.String quantity, java.lang.String bar1, java.lang.String bar2, java.lang.String bar3, java.lang.String bar4, java.lang.String itemName, java.lang.String unitIndex) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 107 (6Bh) Defining and reading items Item programming with unitIndex;
    Specified by:
      `command107Variant1Version1` in class `FiscalDeviceV2`
    Parameters:
      `PLU` - - Item number ( For ECRs 1...100000; For FPs 1...3000 );
      `taxGr` - - VAT group (letter 'A'...'H' or cyrillic);
      `dep` - - Department ( 0...99 );
      `group` - - Stock group (1...99);
      `priceType` - - Price type ('0' - fixed price, '1' - free price, '2' - max price) ;
      `price` - - Price ( 0.00...9999999.99 or 0...999999999 depending dec point position );
      `addQty` - - A byte with value 'A',Change of the available quantity for item;
      `quantity` - - Stock quantity ( 0.001...99999.999 );
      `bar1` - - Barcode X ( up to 13 digits );
      `bar2` -
      `bar3` -
      `bar4` -
      `itemName` - - Item name (up to 72 symbols);
      `unitIndex` - - Measurement unit 0 - 19;
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant2Version0

    public FiscalResponse command107Variant2Version0​(java.lang.String PLU, java.lang.String quantity) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 107 (6Bh) Defining and reading items Change of the available quantity for item;
    Specified by:
      `command107Variant2Version0` in class `FiscalDeviceV2`
    Parameters:
      `PLU` -
      `quantity` -
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant3Version0

    public FiscalResponse command107Variant3Version0​(java.lang.String startPLU, java.lang.String endPLU) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 107 (6Bh) Defining and reading items Item deleting
    Specified by:
      `command107Variant3Version0` in class `FiscalDeviceV2`
    Parameters:
      `startPLU` -
      `endPLU` -
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant3Version1

    public FiscalResponse command107Variant3Version1() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 107 (6Bh) Defining and reading items All items will be deleted !!!
    Specified by:
      `command107Variant3Version1` in class `FiscalDeviceV2`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant4Version0

    public FiscalResponse command107Variant4Version0​(java.lang.String option, java.lang.String PLU) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 107 (6Bh) Reading items (Obsolete command - without unitIndex)
    Specified by:
      `command107Variant4Version0` in class `FiscalDeviceV2`
    Parameters:
      `option` - 'F' - Returns data about the first found programmed item; 'L' - Returns data about the last found programmed item; 'f' - Returns data about the first found item with sales on it; 'l' - Returns data about the last found item with sales on it;
      `PLU` - - Item number ( For ECRs 1...100000; For FPs 1...3000 ). Default: 1;
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant5Version0

    public FiscalResponse command107Variant5Version0​(java.lang.String option, java.lang.String PLU) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 107 (6Bh) Reading items
    Specified by:
      `command107Variant5Version0` in class `FiscalDeviceV2`
    Parameters:
      `option` - 'F' - Returns data about the first found programmed item; 'L' - Returns data about the last found programmed item; 'f' - Returns data about the first found item with sales on it; 'l' - Returns data about the last found item with sales on it; 'X' - Find the first not programmed item; 'x' - Find the last not programmed item;
      `PLU` - - Item number ( For ECRs 1...100000; For FPs 1...3000 ). Default: 1;
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command107Variant6Version0

    public FiscalResponse command107Variant6Version0​(java.lang.String option) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 107 (6Bh) Reading items
    Specified by:
      `command107Variant6Version0` in class `FiscalDeviceV2`
    Parameters:
      `option` - 'N' - Returns data for the next found programmed item; 'n' - Returns data for the next found item with sales on it;
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command109Variant0Version0

    public FiscalResponse command109Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 109 (6Dh) Print duplicate copy of receipt
    Specified by:
      `command109Variant0Version0` in class `FiscalDeviceV2`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command110Variant0Version0

    public FiscalResponse command110Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 110 (6Eh) Additional daily information Payments
    Specified by:
      `command110Variant0Version0` in class `FiscalDeviceV2`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command110Variant1Version0

    public FiscalResponse command110Variant1Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 110 (6Eh) Additional daily information reserved
    Specified by:
      `command110Variant1Version0` in class `FiscalDeviceV2`
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; PayX - Value payed by payment X ( 0.00...9999999.99 or 0...999999999 depending dec point position );. ForeignPay - Value payed by foreign currency ( 0.00...9999999.99 or 0...999999999 depending dec point position );.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command110Variant2Version0

    public FiscalResponse command110Variant2Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 110 (6Eh) Additional daily information number and sum of sells; ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; Num - number of clients; Sum - sum of the sells.
    Specified by:
      `command110Variant2Version0` in class `FiscalDeviceV2`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command110Variant3Version0

    public FiscalResponse command110Variant3Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 110 (6Eh) Additional daily information number and sum of discounts and surcharges
    Specified by:
      `command110Variant3Version0` in class `FiscalDeviceV2`
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; qSur - number of surcharges;. sSur - sum of surcharges;. qDis - number of discounts;. sDis - sum of discounts;.
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command110Variant4Version0

    public FiscalResponse command110Variant4Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 110 (6Eh) Additional daily information number and sum of corrections and annulled receipts;
    Specified by:
      `command110Variant4Version0` in class `FiscalDeviceV2`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command110Variant5Version0

    public FiscalResponse command110Variant5Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 110 (6Eh) Additional daily information number and sum of cash in and cash out operations;
    Specified by:
      `command110Variant5Version0` in class `FiscalDeviceV2`
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command111Variant0Version0

    public FiscalResponse command111Variant0Version0​(java.lang.String reportType, java.lang.String startPLU, java.lang.String endPLU) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 111 (65h) PLU report
    Specified by:
      `command111Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `reportType` - - Type of report; '0' - PLU turnovers; '1' - PLU turnovers with clearing; '2' - PLU parameters; '3' - PLU stock;
      `startPLU` - - First PLU in the report (1...3000). Default: 1;
      `endPLU` - - Last PLU in the report (1...3000). Default: Maximum PLU in the FPr;
    Returns:
      ErrorCode - Indicates an error code. If command passed, ErrorCode is 0;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command112Variant0Version0

    public FiscalResponse command112Variant0Version0​(java.lang.String wpOperator) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 112 (70h) Information for operator
    Specified by:
      `command112Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `wpOperator` - - Number of operator (1...30);
    Returns:
      ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; Receipts - Number of fiscal receipts, issued by the operator (0...65535); Total - Total accumulated sum ( 0.00...9999999.99 or 0...999999999 depending dec point position ); nDiscount - Number of discounts (0...65535);; Discount - Total accumulated sum of discounts with sign ( 0.00...9999999.99 or 0...999999999 depending dec point position ); nSurcharge - Number of surcharges (0...65535); Surcharge - Total accumulated sum of surcharges with sign( 0.00...9999999.99 or 0...999999999 depending dec point position ); nVoid - Number of corrections (0...65535); Void - Total accumulated sum of corrections with sign( 0.00...9999999.99 or 0...999999999 depending dec point position );
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command116Variant0Version0

    public FiscalResponse command116Variant0Version0​(java.lang.String operation, java.lang.String address, java.lang.String nBytes) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 116 (74h) Reading FM.
    Specified by:
      `command116Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `operation` - - type of operation = '0';
      `address` - - Start address 0...FFFFFF ( format ascii-hex ).
      `nBytes` - - Number of bytes (1...104)
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command123Variant0Version0

    public FiscalResponse command123Variant0Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 123 (7Bh) Device information - Serial numbers, Header and Tax numbers;
    Specified by:
      `command123Variant0Version0` in class `FiscalDeviceV2`
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; SerialNumber - Serial number; FiscalNumber - FMemory number; Headerline1 - Supposed to contain Company name ( up to depending on device's maximum printing columns ); Headerline2 - Supposed to contain Company address ( up to depending on device's maximum printing columns ); Headerline3 - Supposed to contain name of the business premises ( up to depending on device's maximum printing columns ); Headerline4 - Supposed to contain address of the business premises ( up to depending on device's maximum printing columns ); TAXnumber
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command123Variant1Version0

    public FiscalResponse command123Variant1Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 123 (7Bh) Device information - Battery and GSM signal status;
    Specified by:
      `command123Variant1Version0` in class `FiscalDeviceV2`
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; MainBattery - Main Battery level in mV; RamBattery - Ram Battery level in mV; Signal - GSM Signal level in percentage; Network - GSM network;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command123Variant3Version0

    public FiscalResponse command123Variant3Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 123 (7Bh) Device information - Last fiscal receipt;
    Specified by:
      `command123Variant3Version0` in class `FiscalDeviceV2`
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; BonFiscal - Number of last sales receipt in current Z report ( 1...9999 ); DateBonFiscal - Date and time of last sales receipt ( format "DD-MM-YYYY hh:mm:ss" ); Znumber - Number of last Z-report ( 1..???? ); Zdate - Date of last of Z-report ( format "DD-MM-YYYY hh:mm:ss" );
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command123Variant4Version0

    public FiscalResponse command123Variant4Version0() throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 123 (7Bh) Device information - Full EJ verify;
    Specified by:
      `command123Variant4Version0` in class `FiscalDeviceV2`
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command124Variant0Version0

    public FiscalResponse command124Variant0Version0​(java.lang.String startDate, java.lang.String endDate, java.lang.String DocType) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 124 (7Ch) Search documents in EJ by date
    Specified by:
      `command124Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `startDate` - - Start date for searching. Default: Date of first document;
      `endDate` - - End date for searching. Default: Date of last document;
      `DocType` - - Receipt type; '0' - all types; '1' - fiscal receipts; '2' - daily Z reports; '3' - invoice receipts; '4' - non fiscal receipts; '5' - paidout receipts; '6' - fiscal receipts - storno; '7' - invoice receipts - storno; '8' - cancelled receipts ( all voided ); '9' - daily X reports; '10' - fiscal receipts, invoice receipts, fiscal receipts - storno and invoice receipts - storno;
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; StartDate - Start date for searching, see DateTime format described at the beginning of the document; EndDate - End date for searching, see DateTime format described at the beginning of the document; FirstDoc - First document in the period, depending "Type" (1...9999999); LastDoc - Last document in the period, depending "Type" (1...9999999);
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command125Variant0Version0

    public FiscalResponse command125Variant0Version0​(java.lang.String docNum, java.lang.String recType) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 125 (7Dh) Information from EJ - Set document to read;
    Specified by:
      `command125Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `docNum` - - Number of document (1...9999999). Needed for Option = 0
      `recType` - - Document type. Needed for Option = 0. '0' - all types; '1' - fiscal receipts; '2' - daily Z reports; '3' - invoice receipts; '4' - nonfiscal receipts; '5' - paidout receipts; '6' - fiscal receipts - storno; '7' - invoice receipts - storno; '8' - cancelled receipts ( all voided ); '9' - daily X reports; '10' - fiscal receipts, invoice receipts, fiscal receipts - storno and invoice receipts - storno;
    Returns:
      - errorCode - Indicates an error code. If command passed, ErrorCode is 0; DocNumber - Number of document ( global 1...9999999 ); RecNumber - Number of document ( depending "Type" ); Date - Date of document, see DateTime format described at the beginning of the document; Type - Type of document; '0' - all types; '1' - fiscal receipts; '2' - daily Z reports; '3' - invoice receipts; '4' - non fiscal receipts; '5' - paidout receipts; '6' - fiscal receipts - storno; '7' - invoice receipts - storno; '8' - cancelled receipts ( all voided ); '9' - daily X reports; Znumber- number of Z report (1...3650);
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command125Variant1Version0

    public FiscalResponse command125Variant1Version0​(java.lang.String FirstDoc, java.lang.String LastDoc) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 125 (7Dh) Information from EJ - Read one line as text. Must be called multiple times to read the whole document;
    Specified by:
      `command125Variant1Version0` in class `FiscalDeviceV2`
    Parameters:
      `FirstDoc` - - First document in the period (1...99999999). Number received in response to command 124;
      `LastDoc` - - Last document in the period. (1...99999999). Number received in response to command 124;
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; TextData - Document text (up to 64 chars);
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command125Variant2Version0

    public FiscalResponse command125Variant2Version0​(java.lang.String FirstDoc, java.lang.String LastDoc) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Command: 125 (7Dh) Information from EJ - Read as data. Must be called multiple times to read the whole document;
    Specified by:
      `command125Variant2Version0` in class `FiscalDeviceV2`
    Parameters:
      `FirstDoc` - - First document in the period (1...99999999). Number received in response to command 124;
      `LastDoc` - - Last document in the period. (1...99999999). Number received in response to command 124;
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; Data - Document data, structured information in base64 format. Detailed information in other document;
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command125Variant3Version0

    public FiscalResponse command125Variant3Version0​(java.lang.String option, java.lang.String docNum, java.lang.String recType) throws java.io.IOException, FiscalException, java.lang.IllegalArgumentException
    Specified by:
      `command125Variant3Version0` in class `FiscalDeviceV2`
    Parameters:
      `option` -
      `docNum` -
      `recType` -
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`
      `java.lang.IllegalArgumentException`

  - ### command127Variant0Version0

    public FiscalResponse command127Variant0Version0​(java.lang.String typeOper, java.lang.String stampName) throws java.io.IOException, FiscalException
    Command: 127 (7Fh) Stamp operations (bitmap printing)
    Specified by:
      `command127Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `typeOper` - - Type of operation; '0' - Print stamp; '1' - Rename loaded stamp with command 203;
      `stampName` - - Name of stamp as filename in format 8.3;
    Returns:
      ErrorCode - Indicates an error code. If command passed, ErrorCode is 0;
    Throws:
      `java.io.IOException`
      `FiscalException`

  - ### command140Variant0Version0

    public FiscalResponse command140Variant0Version0() throws java.io.IOException, FiscalException
    Command: 140 (8Ch) Defining and reading clients Clients information;
    Specified by:
      `command140Variant0Version0` in class `FiscalDeviceV2`
    Returns:
      - ErrorCode - Indicates an error code. If command passed, ErrorCode is 0; Total - Total count of the programmable clients (1000); Prog - Total count of the programmed clients (0...1000); NameLen - Maximum length of client name (36);
    Throws:
      `java.io.IOException`
      `FiscalException`

  - ### command140Variant1Version0

    public FiscalResponse command140Variant1Version0​(java.lang.String FIRM, java.lang.String Name, java.lang.String TypeTAXN, java.lang.String TAXN, java.lang.String RecName, java.lang.String VATN, java.lang.String Addr1, java.lang.String Addr2) throws java.io.IOException, FiscalException
    Command: 140 (8Ch) Defining and reading clients Clients programming;
    Specified by:
      `command140Variant1Version0` in class `FiscalDeviceV2`
    Parameters:
      `FIRM` - - Client number, index of record (1...1000);
      `Name` - - Client's name (up to 36 chars);
      `TypeTAXN` - - Client's tax number (9...13 chars);
      `TAXN` - - Ð¢ype of TAXN: '0' - BULSTAT; '1' - EGN; '2' - LNCH; '3' - service number;
      `RecName` - - RecName - Reciever's name (up to 36 chars);
      `VATN` - - VAT number of the client (up to 14 chars);
      `Addr1` - - Client's address - line 1 (up to 36 chars);
      `Addr2` - - Client's address - line 2 (up to 36 chars);
    Returns:
      errorCode[SEP]
    Throws:
      `java.io.IOException`
      `FiscalException`

  - ### command140Variant2Version0

    public FiscalResponse command140Variant2Version0​(java.lang.String firstFIRM, java.lang.String lastFIRM) throws java.io.IOException, FiscalException
    Command: 140 (8Ch) Defining and reading clients Client deleting;
    Specified by:
      `command140Variant2Version0` in class `FiscalDeviceV2`
    Parameters:
      `firstFIRM` - - Client number, index of record (1...1000);
      `lastFIRM` - - Client's name (up to 36 chars);
    Returns:
      errorCode[SEP]
    Throws:
      `java.io.IOException`
      `FiscalException`

  - ### command140Variant3Version0

    public FiscalResponse command140Variant3Version0​(java.lang.String FIRM) throws java.io.IOException, FiscalException
    Command: 140 (8Ch) Defining and reading clients Reading client data;
    Specified by:
      `command140Variant3Version0` in class `FiscalDeviceV2`
    Parameters:
      `FIRM` - - Client number, index of record (1...1000);
    Returns:
      errorCode - Indicates an error code. If command passed, ErrorCode is 0; FIRM - Client number, index of record (1...1000); TAXN - Client's tax number (9...13 chars); TypeTAXN - Ð¢ype of TAXN: '0' - BULSTAT; '1' - EGN; '2' - LNCH; '3' - service number; VATN - VAT number of the client (up to 14 chars); Name - Client's name (up to 36 chars); RecName - Reciever's name (up to 36 chars); Addr1 - Client's address - line 1 (up to 36 chars); Addr2 - Client's address - line 2 (up to 36 chars);
    Throws:
      `java.io.IOException`
      `FiscalException`

  - ### command140Variant4Version0

    public FiscalResponse command140Variant4Version0​(java.lang.String Option, java.lang.String startOrTAXN) throws java.io.IOException, FiscalException
    Command: 140 (8Ch) Defining and reading clients Reading client data;
    Specified by:
      `command140Variant4Version0` in class `FiscalDeviceV2`
    Parameters:
      `Option` - -'F' - Returns data about the first found programmed client; -'L' - Returns data about the last found programmed client; -'N' - Returns data for the next found programmed client; -'T' - Find a client by tax number;
      `startOrTAXN` - - Client's tax number (9...13 chars) for option 'T'
    Returns:
      errorCode - Indicates an error code. If command passed, ErrorCode is 0; FIRM - Client number, index of record (1...1000); TAXN - Client's tax number (9...13 chars); TypeTAXN - Ð¢ype of TAXN: '0' - BULSTAT; '1' - EGN; '2' - LNCH; '3' - service number; VATN - VAT number of the client (up to 14 chars); Name - Client's name (up to 36 chars); RecName - Reciever's name (up to 36 chars); Addr1 - Client's address - line 1 (up to 36 chars); Addr2 - Client's address - line 2 (up to 36 chars);
    Throws:
      `java.io.IOException`
      `FiscalException`

  - ### command140Variant5Version0

    public FiscalResponse command140Variant5Version0​(java.lang.String Option, java.lang.String startFIRM) throws java.io.IOException, FiscalException
    Command: 140 (8Ch) Defining and reading clients
    Specified by:
      `command140Variant5Version0` in class `FiscalDeviceV2`
    Parameters:
      `Option` - 'X' - Find the first not programmed client; 'x' - Find the last not programmed client;
    Returns:
      - errorCode - Indicates an error code. If command passed, ErrorCode is 0; - FIRM - Client number (1...1000);
    Throws:
      `java.io.IOException`
      `FiscalException`

  - ### command144Variant0Version0

    public FiscalResponse command144Variant0Version0​(java.lang.String OperationType, java.lang.String Command) throws java.io.IOException, FiscalException
    Command: 144 (90h) Read NAP parameters.
    Specified by:
      `command144Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `OperationType` - - type of operation; '1' or '2'
      `Command` - 2 - FD type, (1 char); 3 - EIK (up to 16 chars); 4 - EIK type (1 char); 5 - ID of the FD (up to 16 chars); 6 - ID of the fiscal memory of the FD (up to 16 chars); 7 - FD registration number (up to 16 chars); 8 - Reason for deregistration (up to 2 chars); 9 - Certificate number (up to 16 chars); 10 - IMSI (up to 32 chars); 11 - Telephone number (up to 16 chars); 12 - Operator ID (1 char); 13 - Name of the organization (up to 200 chars); 14 - PS number (up to 16 chars); 15 - PS type (up to 3 chars); 16 - EKATTE code (up to 16 chars); 17 - Settlement name (up to 64 chars); 18 - Area code (up to 16 chars); 19 - Area (up to 100 chars); 20 - Street code (up to 16 chars); 21 - Street (up to 100 chars); 22 - Street number (up to 16 chars); 23 - Block (up to 16 chars); 24 - Entrance (up to 16 chars); 25 - Floor (up to 16 chars); 26 - Apartment (up to 16 chars); 27 - PS name (up to 200 chars); 28 - Exploitation start date (up to 19 chars); 29 - Service organization EIK (up to 16 chars); 30 - Service organization EIK type (1 char); 31 - Date of expiration of service contract (up to 19 chars); 32 - APN (up to 100 chars); 33 - IP (up to 200 chars);; 34 - Port (up to 5 chars); 35 - APN name (up to 32 chars); 36 - APN password (up to 32 chars); 37 - fixed to 115200; 38 - fixed to 115200; 40 - Datecs server connection APN (up to 64 chars); 41 - Datecs server connection APN name (up to 64 chars); 42 - Datecs server connection APN pass (up to 64 chars);
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`

  - ### command202Variant1Version0

    public FiscalResponse command202Variant1Version0​(java.lang.String data) throws java.io.IOException, FiscalException
    Specified by:
      `command202Variant1Version0` in class `FiscalDeviceV2`
    Parameters:
      `data` - START - Praparation for data loading; STOP - End of data; YmFzZTY0ZGF0YQ== - base64 coded data of the grahpic logo; POWEROFF - Shutting down the device; RESTART - Device restarting;
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`

  - ### command202Variant0Version0

    public FiscalResponse command202Variant0Version0​(java.lang.String data) throws java.io.IOException, FiscalException
    Specified by:
      `command202Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `data` - START - Praparation for data loading; STOP - End of data; YmFzZTY0ZGF0YQ== - base64 coded data of the grahpic logo; POWEROFF - Shutting down the device; RESTART - Device restarting;
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`

  - ### command203Variant1Version0

    public FiscalResponse command203Variant1Version0​(java.lang.String data) throws java.io.IOException, FiscalException
    Specified by:
      `command203Variant1Version0` in class `FiscalDeviceV2`
    Parameters:
      `data` - START - Praparation for data loading;* POWEROFF - Shutting down the device; RESTART - Device restarting;
    Returns:
      - errorCode - Indicates an error code. If command passed, ErrorCode is 0;
    Throws:
      `java.io.IOException`
      `FiscalException`

  - ### command203Variant0Version0

    public FiscalResponse command203Variant0Version0​(java.lang.String data) throws java.io.IOException, FiscalException
    Specified by:
      `command203Variant0Version0` in class `FiscalDeviceV2`
    Parameters:
      `data` -
    Returns:
    Throws:
      `java.io.IOException`
      `FiscalException`

  - ### Command255Read

    public FiscalResponse Command255Read​(FiscalDeviceV2.cmd255Name cmdName, java.lang.String cmdIndex) throws FiscalException, java.io.IOException
    Specified by:
      `Command255Read` in class `FiscalDeviceV2`
    Parameters:
      `cmdName` -
      `cmdIndex` -
    Returns:
    Throws:
      `FiscalException`
      `java.io.IOException`

  - ### Command255Write

    public FiscalResponse Command255Write​(FiscalDeviceV2.cmd255Name cmdName, java.lang.String cmdIndex, java.lang.String cmdValue) throws FiscalException, java.io.IOException
    Specified by:
      `Command255Write` in class `FiscalDeviceV2`
    Parameters:
      `cmdName` -
      `cmdIndex` -
      `cmdValue` -
    Returns:
    Throws:
      `FiscalException`
      `java.io.IOException`

  - ### getPrintColumnsSupported

    public java.lang.String[] getPrintColumnsSupported()
    Specified by:
      `getPrintColumnsSupported` in class `FiscalDeviceV2`

  - ### getCapAutoCutter

    public boolean getCapAutoCutter()
    Specified by:
      `getCapAutoCutter` in class `FiscalDeviceV2`

  - ### getcapFontSupported

    public boolean getcapFontSupported()
    Specified by:
      `getcapFontSupported` in class `FiscalDeviceV2`

  - ### getMAX_PLU

    public java.lang.Integer getMAX_PLU()
    Specified by:
      `getMAX_PLU` in class `FiscalDeviceV2`

  - ### getMaxNonFiscalText

    public int getMaxNonFiscalText()
    Specified by:
      `getMaxNonFiscalText` in class `FiscalDeviceV2`

  - ### getMaxTextHeaderFooter

    public int getMaxTextHeaderFooter()
    Specified by:
      `getMaxTextHeaderFooter` in class `FiscalDeviceV2`

  - ### isCapHasCutter

    public boolean isCapHasCutter()
    Specified by:
      `isCapHasCutter` in class `FiscalDeviceV2`

  - ### iscapFontSupported

    public boolean iscapFontSupported()
    Specified by:
      `iscapFontSupported` in class `FiscalDeviceV2`

  - ### getMaxLogoW

    public java.lang.Integer getMaxLogoW()
    Specified by:
      `getMaxLogoW` in class `FiscalDeviceV2`

  - ### getMaxLogoH

    public java.lang.Integer getMaxLogoH()
    Specified by:
      `getMaxLogoH` in class `FiscalDeviceV2`

  - ### getCurrentOpCode

    public java.lang.String getCurrentOpCode() throws java.io.IOException, FiscalException
    Specified by:
      `getCurrentOpCode` in class `FiscalDeviceV2`
    Returns:
      Note: WP-500X, WP-50X, WP-25X, DP-25X, DP-150X, DP-05C: the default password for each operator is equal to the corresponding number (for example, for Operator1 the password is "1") . FMP-350X, FMP-55X, FP-700X: the default password for each operator is "0000"
    Throws:
      `java.io.IOException`
      `FiscalException`

  - ### getDefaultOpPass

    public java.lang.String getDefaultOpPass() throws java.io.IOException, FiscalException
    Specified by:
      `getDefaultOpPass` in class `FiscalDeviceV2`
    Throws:
      `java.io.IOException`
      `FiscalException`